/**
  *an exception class for dealing with a Graph data structer.
  */
public class GraphException extends RuntimeException 
{

   /**
     *thows a graph exception.<BR>
     *<B>Preconditions</B><BR>
     *<UL>
     *   <LI>error must have occured in program
     *</UL><BR>
     *<B>Postconditions</B><BR>
     *<UL>
     *   <LI>an exception with no discription will be thrown
     *</UL>
     */

  public GraphException() 
  {
  }  // end default constructor

   /**
     *thows a graph exception.<BR>
     *<B>Preconditions</B><BR>
     *<UL>
     *   <LI>error must have occured in program
     *</UL><BR>
     *<B>Postconditions</B><BR>
     *<UL>
     *   <LI>an exception with discription will be thrown
     *</UL>
     */
  public GraphException(String s) 
  {
    super(s);
  }  // end  constructor
}  // end GraphException
