//Almost all this code is ripped from my other popup
//menu and my menubar, therefore it's VERY MESSY. If you
//want to see how this works, look at the other popup menu or 
//the menu bar

/**
  *a class to generate the right click popup.
  */


import java.awt.Color;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;
import javax.swing.JOptionPane;
import javax.swing.JFrame;
import javax.swing.JPopupMenu;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JColorChooser;
import javax.swing.JCheckBoxMenuItem;


public class GraphRPop extends JPopupMenu implements ActionListener
{


       private JMenu m_color = new JMenu("Colors");
         private JMenuItem mi_bcolor = new JMenuItem("Background",KeyEvent.VK_G);
         private JMenuItem mi_ncolor = new JMenuItem("Nodes",KeyEvent.VK_O);
         private JMenuItem mi_lcolor = new JMenuItem("Lines",KeyEvent.VK_L);
         private JMenuItem mi_tcolor = new JMenuItem("Text",KeyEvent.VK_T);
       private JMenuItem mi_radius = new JMenuItem("Set Node Radius",KeyEvent.VK_R);
       private JMenuItem mi_original= new JMenuItem("Restore Defaults",KeyEvent.VK_D);
       private JMenuItem mi_custom  = new JMenuItem("Remove Customization",KeyEvent.VK_C);

       private JMenuItem mi_clear = new JMenuItem("Clear Search",KeyEvent.VK_S);
       private JCheckBoxMenuItem mi_weight = new JCheckBoxMenuItem("Display Weights");
       private JCheckBoxMenuItem mi_direction = new JCheckBoxMenuItem("Display Direction");


   private JGraph graph;


   /**
     *a right click popup.
     *@param j the JGraph from which to get the information from/to.
     *@param x the x location of the popup.
     *@param y the y location of the popup.
     */
   public GraphRPop(JGraph j, int x, int y)
   {
      graph = j; //assign class wide instance var


      //construct popup menu
        //color
        m_color.add(mi_bcolor);
        m_color.add(mi_ncolor);
        m_color.add(mi_lcolor);
        m_color.add(mi_tcolor);
     this.add(mi_direction);
     this.add(mi_weight);
    this.addSeparator();
     this.add(mi_clear);
    this.addSeparator();
     this.add(m_color);
     this.add(mi_radius);
    this.addSeparator();
     this.add(mi_original);
     this.add(mi_custom);

      //listeners
      mi_clear.addActionListener(this);
      mi_bcolor.addActionListener(this);
      mi_tcolor.addActionListener(this);
      mi_ncolor.addActionListener(this);
      mi_lcolor.addActionListener(this);
      mi_original.addActionListener(this);
      mi_radius.addActionListener(this);
      mi_weight.addActionListener(this);
      mi_direction.addActionListener(this);
      mi_custom.addActionListener(this);

      //cut and pasted from GraphGUI menulistener, dynimically assigns values to menu items
          //what should be enable?
          if(graph.getSearchVector() == null) //sets the "Clear Search" greyed out state
           { mi_clear.setEnabled(false); }
          else
           { mi_clear.setEnabled(true); }

          if(graph.isWeighted()) //sets the enabled status of "show weights"
           { mi_weight.setEnabled(true); }
          else
           { mi_weight.setEnabled(false); }

          if(graph.isDirected()) //sets the enabled status of "show arrows"
           { mi_direction.setEnabled(true); }
          else
           { mi_direction.setEnabled(false); }

          //what are the current setting?
          if(graph.getArrows() == true && graph.isDirected() ) //are the arrows being drawn
            {mi_direction.setSelected(true);}
          else
            {mi_direction.setSelected(false);}
          if(graph.getWeights() == true && graph.isWeighted() ) //does the user want weights drawn
            {mi_weight.setSelected(true);}
          else
            {mi_weight.setSelected(false);}


      //j is invoker, x and y are cords
      this.show(j,x,y);
   }





   public void actionPerformed(ActionEvent e)
   {
      if(e.getSource() == mi_weight) //display status of weights
        {
          if(graph.getWeights() == true) //if on turn off
           { graph.setWeights(false); }
          else if(graph.getWeights() == false) //if off turn on
           { graph.setWeights(true); }
        }
      else if(e.getSource() == mi_clear)
        { graph.clearSearch(); }
      else if(e.getSource() == mi_direction)
        {
          if(graph.getArrows() == true) //if on turn off
           { graph.setArrows(false); }
          else if(graph.getArrows() == false) //if off turn on
           { graph.setArrows(true); }
        }
      else if(e.getSource() == mi_bcolor)
        {
          boolean btest = true;
           while (btest) //if they didn't click cancel
           {
             Color bcolor = JColorChooser.showDialog(new JFrame(),"Background Color",graph.getBackground()); //give them a dialogue with the existing color selected              
               if(bcolor != null && (bcolor.equals(graph.getTextColor()) || bcolor.equals(graph.getNodeColor()) || bcolor.equals(graph.getLineColor() )) ) //make sure colors don't clash
               {  JOptionPane.showMessageDialog(new JFrame(),"Background color can not be the same as node, line or text color","Error",JOptionPane.ERROR_MESSAGE);}              else if(bcolor != null)
               {  graph.setBackground(bcolor);
                  btest=false;
               }
              else
               { btest = false; } //break us out of loop if they hit cancle
           }
        }
      //change default node color
      else if(e.getSource() == mi_ncolor)
      {
           boolean ntest = true;
           while (ntest) //if they didn't click cancel
           {
             Color ncolor = JColorChooser.showDialog(new JFrame(),"Node Color",graph.getNodeColor()); //give them a dialogue with the existing color selected
              if(ncolor != null && (ncolor.equals(graph.getTextColor()) || ncolor.equals(graph.getBackground())) ) //make sure colors don't clash
               {  JOptionPane.showMessageDialog(new JFrame(),"Node color can not be the same as background or text color","Error",JOptionPane.ERROR_MESSAGE);}
              else if(ncolor != null)
               {  graph.setNodeColor(ncolor);
                  ntest=false;
               }
              else
               { ntest = false; } //break us out of loop if they hit cancle
           }
      }
      //change default text color
      else if(e.getSource() == mi_tcolor)
      {
        boolean ttest = true;
        while(ttest)
        {
           Color tcolor = JColorChooser.showDialog(new JFrame(),"Text Color",graph.getTextColor()); //give them a dialogue with the existing color selected
           if (tcolor != null) //if they didn't click cancel
           {
              if(tcolor.equals(graph.getBackground()) || tcolor.equals(graph.getNodeColor()) ) //make sure colors don't clash
               {  JOptionPane.showMessageDialog(new JFrame(),"Text color can not be the same as background or node color","Error",JOptionPane.ERROR_MESSAGE);}
              else
               {
                 graph.setTextColor(tcolor);
                 ttest = false;
               }
           }
           else
           { ttest = false; }
        }
      }
      //change default line color
      else if(e.getSource() == mi_lcolor)
      {
        boolean ltest = true;
        while(ltest)
        {
           Color lcolor = JColorChooser.showDialog(new JFrame(),"Line Color",graph.getLineColor()); //give them a dialogue with the existing color selected
           if (lcolor != null) //if they didn't click cancel
           {
              if(lcolor.equals(graph.getBackground()) ) //make sure colors don't clash
               {  JOptionPane.showMessageDialog(new JFrame(),"Line color can not be the same as background color","Error",JOptionPane.ERROR_MESSAGE);}
              else
               {
                 graph.setLineColor(lcolor);
                 ltest = false;
               }
           }
           else
           { ltest = false; }
        }
      }
      else if(e.getSource() ==mi_radius)
      {
             //NOTE -- taken and modified from the popup menu class
          boolean valid = false;
          Integer i = new Integer(graph.getRadius());
          while(valid == false)
          {
            Object str_rad = JOptionPane.showInputDialog(new JFrame(), "Radius of Node", "Radius",JOptionPane.QUESTION_MESSAGE,null,null,i);
            if(str_rad != null) //if user didn't click cancle
            {
              try
              {
                int x = Integer.parseInt((String) str_rad); //check to see if they entered an integer
                if(x > 0) //check to see if int was positive
                 {
                    graph.setRadius(x); //set the new radius
                    valid = true; //break out of loop
                 }
                else
                 {  throw new NumberFormatException("Invalid radius"); } //rethrow exception for invalid numbers
              }
              catch(NumberFormatException f)
              {
                 JOptionPane.showMessageDialog(new JFrame(), "Invalid Radius", "Error", JOptionPane.ERROR_MESSAGE);
              }
            }
            else
              {valid = true;} //user clicked cancle
          }//end while loop
      }//end radius change if statement

      else if(e.getSource() == mi_custom) //remove customized nodes
      {
         if(JOptionPane.showConfirmDialog(new JFrame(), "Are you sure you want to remove all custom colors from the nodes and reset their radii?","Reset Custom Nodes",JOptionPane.YES_NO_OPTION,JOptionPane.QUESTION_MESSAGE) == 0)
         {
            graph.resetAllNodes();
         }
      }

      else if(e.getSource() == mi_original) //restore defaults
      {
         if(JOptionPane.showConfirmDialog(new JFrame(), "Are you sure you want to restore the default colors and radii","Reset Default Options",JOptionPane.YES_NO_OPTION,JOptionPane.QUESTION_MESSAGE) == 0)
         {
            graph.resetDefaults();
         }
      }



   }


}
